import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.GradientType;
import flash.display.Shape;
import flash.display.Sprite;
import flash.events.Event;
import flash.filters.GlowFilter;
import flash.geom.Matrix;
import flash.geom.Point;
import flash.geom.Rectangle;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flash.text.TextFormat;

import flash.Lib;

class Letter extends Sprite {
	public var offset		: Float;	// Décalage en Y et variable d'incrementation propre à la lettre
	public var xStartPos	: Float;	// Position de départ de la lettre
	
	// On créé une lettre en dégradé de couleurs sans incorporer la police de caractère dans le SWF
	public function new( char : String ) {
		super(); // Et ouais, bien sûr que c'est super ! ;)
		
		// On créé le champ de texte pour la lettre 
		var tfx = new TextFormat( "Tahoma", 40, true );
		var tf = new TextField();
		tf.selectable = false;
		tf.text = char;
		tf.autoSize = TextFieldAutoSize.LEFT;
		tf.setTextFormat( tfx );
		
		//On créé un carré dégradé de couleurs
		var fill = new Shape();
		var matrix = new Matrix();
		matrix.createGradientBox( tf.width, tf.height, -Math.PI / 2 );
		fill.graphics.beginGradientFill( GradientType.LINEAR, [ 0x0000FF, 0xFF00C0, 0xFF0000 ], [ 1, 1, 1 ], [ 0, 128, 255 ], matrix );
		fill.graphics.drawRect( 0, 0, tf.width, tf.height );
		fill.graphics.endFill();
		
		// On créé un bitmap à partir du champ de texte de la lettre
		var bmpd = new BitmapData( Std.int ( tf.width ), Std.int( tf.height ), true, 0 );
		bmpd.draw( tf );
		var bmp = new Bitmap( bmpd );
		
		// On créé un bitmap à partir du dégradé de couleurs
		var bmpd2 = new BitmapData( Std.int ( tf.width ), Std.int( tf.height ), true, 0 );
		bmpd2.draw( fill );
		var bmp2 = new Bitmap( bmpd2 );
		
		// On découpe le dégradé de couleurs en forme de la lettre
		bmpd2.copyChannel( bmpd, new Rectangle( 0, 0, Std.int ( tf.width ), Std.int( tf.height ) ), new Point( 0, 0 ), 8, 8 );
		
		// On libere la mémoire du bitmap qui ne sert plus à rien
		bmpd.dispose();
		
		// On ajoute un contour noir à la lettre en couleur
		filters = [ new GlowFilter( 0, 1, 2, 2, 3, 3 ) ];
		
		addChild( bmp2 );		
	}
}

class Banner {
	var letters	: Array<Letter>;
	
	function new() {
		letters = new Array();
		var text = "haXe Facile !";
		var container = new Sprite();
		
		// On créé une lettre colorée à partir de la phrase de départ
		for ( i in 0...text.length ) {
			var l = new Letter( text.substr( i, 1 ) );
			l.offset = ( ( 2 * Math.PI ) / text.length ) * i;	// Décalage en Y de départ pour chaque lettre pour créer une sinusoïde
			l.x = l.xStartPos = container.width; 				// On définit la position de départ de chaque lettre en X
			letters.push( l );
			container.addChild( l );
		}
		
		// On centre le tout à l'écran
		container.x = ( Lib.current.stage.stageWidth - container.width ) / 2;
		container.y = ( Lib.current.stage.stageHeight - container.height ) / 2;
		
		Lib.current.addChild( container );
		container.addEventListener( Event.ENTER_FRAME, sineLoop );
	}
	
	// Fonction de rappel appelée à la fréquence du SWF qui fait osciller toutes les lettres
	function sineLoop( e : Event ) {
		for ( i in letters ) {
			i.offset += 0.2;
			i.scaleX = i.scaleY = 0.75 + Math.sin( i.offset ) * 0.25;
			i.y = Math.sin( i.offset ) * 20;
			i.x = i.xStartPos + Math.cos( i.offset ) * Math.sin( i.offset / 25 ) * 150;
		}
	}
	
	// Point d'entrée du programme haXe
	static function main() {
		var v = new Banner();
	}
	
}